﻿using DevExpress.Persistent.Base;
using DevExpress.Persistent.BaseImpl;
using DevExpress.Xpo;

namespace ImportDataFromExcel.Module.BusinessObjects
{
	// Represents the Department class that contains its name 
	// and references all the locations of the department's offices.
    [DefaultClassOptions]
	public class Department : BaseObject
    {
        public Department(Session session) : base(session) { }
        public string Name
        {
            get { return fName; }
            set { SetPropertyValue(nameof(Name), ref fName, value); }
        }
        string fName;

        // Apply the Association attribute to mark the Locations property 
        // as the many end of the LocationsDepartments association.
        [Association("LocationsDepartments")]
        public XPCollection<Location> Locations
        {
            get { return GetCollection<Location>(nameof(Locations)); }
        }
    }
}
