﻿using DevExpress.Persistent.Base;
using DevExpress.Persistent.BaseImpl;
using DevExpress.Xpo;

namespace ImportDataFromExcel.Module.BusinessObjects
{
	// Represents the Location class that contains its name and information
	// about the departments at the location.
	[DefaultClassOptions]
    public class Location : BaseObject
    {
        public Location(Session session) : base(session) { }
        public string Name
        {
            get { return fName; }
            set { SetPropertyValue(nameof(Name), ref fName, value); }
        }
        string fName;

        // Apply the Association attribute to mark the Departments property 
        // as the many end of the LocationsDepartments association.
        [Association("LocationsDepartments")]
        public XPCollection<Department> Departments
        {
            get { return GetCollection<Department>(nameof(Departments)); }
        }
    }
}
